/*
 *	analy_alpha.cc
 */

/*	Copyright (C) 1999, 2000 Sebastian Biallas (sb@web-productions.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <string.h>
#include "analy_alpha.h"
#include "alphadis.h"
#include "htiobox.h"

/*
 *
 */
void analy_alpha_disassembler::init(analyser *A)
{
	analy_disassembler::init(A);
}

/*
 *
 */
int  analy_alpha_disassembler::load(ht_stream *f)
{
	return 0;
}

/*
 *
 */
void analy_alpha_disassembler::done()
{
	analy_disassembler::done();
}

/*
 *
 */
ADDR	analy_alpha_disassembler::branchaddr(OPCODE *opcode)
{
	ADDR		Addr = INVALID_ADDR;
	char *opcode_str = disasm->str(opcode, 0);
	sscanf(opcode_str, "%*s %lx", &Addr);
	return Addr;
}

/*
 *
 */
void analy_alpha_disassembler::init_disasm()
{
	dprintf("analy_alpha_disassembler: initing alphadis\n");
	warnbox_c("\elPlease note, that the Alpha disassembler can be considered as pre-alpha!\nI don't have an alphaprocessor nor will I ever have one so please report any bugs (opcode+correct disassembly)!\n\n\n");
	disasm = new alphadis();
	if (analy) analy->setdisasm(disasm);
}

/*
 *
 */
tbranchtype analy_alpha_disassembler::isbranch(OPCODE *opcode)
{
	char *opcode_str = disasm->str(opcode, 0);

	// FIXME: needs work!!
	if (strncmp("ret", opcode_str, 3)==0) {
		return brreturn;
	} else return brnobranch;
}

/*
 *
 */
void analy_alpha_disassembler::store(ht_stream *f)
{
}

