/*
 *	analy_x86.cc
 */

/*	Copyright (C) 1999, 2000 Sebastian Biallas (sb@web-productions.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *   published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "x86dis.h"
#include "analy_x86.h"
#include <string.h>

/*
 *
 */
void analy_x86_disassembler::init(analyser *A)
{
	analy_disassembler::init(A);
}

/*
 *
 */
int  analy_x86_disassembler::load(ht_stream *f)
{
	return 0;
}

/*
 *
 */
void analy_x86_disassembler::done()
{
	analy_disassembler::done();
}

/*
 *
 */
ADDR	analy_x86_disassembler::branchaddr(OPCODE *opcode)
{
	ADDR		Addr = INVALID_ADDR;
	char *opcode_str = disasm->str(opcode, 0);
	sscanf(opcode_str, "%*s %lx", &Addr);
	return Addr;
}

/*
 *
 */
void analy_x86_disassembler::init_disasm()
{
	dprintf("analy_x86_disassembler: initing x86dis\n");
	// FIXME: OPSIZE32 should be variable
	disasm = new x86dis(X86_OPSIZE32, X86_ADDRSIZE32);
	if (analy) analy->setdisasm(disasm);
}

/*
 *
 */
tbranchtype analy_x86_disassembler::isbranch(OPCODE *opcode)
{
	char *opcode_str = disasm->str(opcode, 0);

	if (*opcode_str=='j') {
		if (*(++opcode_str)=='m') return brjump; else return brjXX;
	} else if ((*opcode_str=='l') && (*(opcode_str+1)=='o')) {
		// loop opcode will be threated like a jXX
		return brjXX;
	} else if (strncmp("call", opcode_str, 4)==0) {
		return brcall;
	} else if (strncmp("ret", opcode_str, 3)==0) {
		return brreturn;
	} else return brnobranch;
}

/*
 *
 */
void analy_x86_disassembler::store(ht_stream *f)
{
}


