/* 
 *	HT Editor
 *	htatom.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htatom.h"
#include "htdebug.h"

#include <string.h>

#define MAX_ATOM_COUNT 128

struct atom_s {
	int id;
	void *data;
};

atom_s *atom[MAX_ATOM_COUNT];
int atom_count=0;

void *find_atom(int id)
{
	for (int i=0; i<atom_count; i++) {
		if (atom[i]->id==id) return atom[i]->data;
	}
	return 0;
}

int register_atom(int id, void *data)
{
	if (!find_atom(id)) {
		atom_s *e=new atom_s;
		e->id=id;
		e->data=data;
		atom[atom_count++]=e;
		assert(atom_count<MAX_ATOM_COUNT);
		return 1;
	}
	return 0;
}

int unregister_atom(int id)
{
	for (int i=0; i<atom_count; i++) {
		if (atom[i]->id==id) {
			delete atom[i];
			atom_count--;
			memmove(atom[i], atom[i+1], (atom_count-i)* sizeof atom[i]);
			return 1;
		}
	}
	return 0;
}

