/*
 *	HT Editor
 *	htcolor.h
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __HTCOLOR_H__
#define __HTCOLOR_H__

#define PCLASS_WINDIALOG		0
#define PCLASS_MENU     		1
#define PCLASS_HELP     		2
#define PCLASS_KEYLINE  		3
#define PCLASS_DESKTOP  		4

/*
 *	WinDialog palette
 */

#define window_palette_str						windialog_black_palette_str
#define dialog_palette_str						windialog_gray_palette_str

#define windialog_cyan_palette_str					"windialog (cyan)"
#define windialog_black_palette_str				"windialog (black)"
#define windialog_blue_palette_str					"windialog (blue)"
#define windialog_gray_palette_str					"windialog (gray)"
#define windialog_special_palette_str				"windialog (special)"

#define windialog_palette_colors           			21

#define windialog_coloridx_body					0
#define windialog_coloridx_shortcut				1
#define windialog_coloridx_frame_focused			2
#define windialog_coloridx_frame_unfocused			3
#define windialog_coloridx_frame_moved    			4
#define windialog_coloridx_frame_killer				5
#define windialog_coloridx_scrollbar				6

#define windialog_coloridx_input_focused			7
#define windialog_coloridx_input_unfocused			8
#define windialog_coloridx_input_clip 				9

#define windialog_coloridx_button_focused			10
#define windialog_coloridx_button_unfocused			11
#define windialog_coloridx_button_shadow 			12
#define windialog_coloridx_button_shortcut			13

#define windialog_coloridx_list_focused_selected		14
#define windialog_coloridx_list_focused_unselected	15
#define windialog_coloridx_list_unfocused_selected	16
#define windialog_coloridx_list_unfocused_unselected	17

#define windialog_coloridx_cluster_focused			18
#define windialog_coloridx_cluster_unfocused			19
#define windialog_coloridx_cluster_shortcut			20

#define windialog_color_body						pal[windialog_coloridx_body].value
#define windialog_color_shortcut					pal[windialog_coloridx_shortcut].value
#define windialog_color_frame_focused				pal[windialog_coloridx_frame_focused].value
#define windialog_color_frame_unfocused				pal[windialog_coloridx_frame_unfocused].value
#define windialog_color_frame_moved				pal[windialog_coloridx_frame_moved].value
#define windialog_color_frame_killer				pal[windialog_coloridx_frame_killer].value
#define windialog_color_scrollbar					pal[windialog_coloridx_scrollbar].value

#define windialog_color_input_focused				pal[windialog_coloridx_input_focused].value
#define windialog_color_input_unfocused				pal[windialog_coloridx_input_unfocused].value
#define windialog_color_input_clip					pal[windialog_coloridx_input_clip].value

#define windialog_color_button_focused				pal[windialog_coloridx_button_focused].value
#define windialog_color_button_unfocused			pal[windialog_coloridx_button_unfocused].value
#define windialog_color_button_shadow				pal[windialog_coloridx_button_shadow].value
#define windialog_color_button_shortcut				pal[windialog_coloridx_button_shortcut].value

#define windialog_color_list_focused_selected		pal[windialog_coloridx_list_focused_selected].value
#define windialog_color_list_focused_unselected		pal[windialog_coloridx_list_focused_unselected].value
#define windialog_color_list_unfocused_selected		pal[windialog_coloridx_list_unfocused_selected].value
#define windialog_color_list_unfocused_unselected		pal[windialog_coloridx_list_unfocused_unselected].value

#define windialog_color_cluster_focused				pal[windialog_coloridx_cluster_focused].value
#define windialog_color_cluster_unfocused			pal[windialog_coloridx_cluster_unfocused].value
#define windialog_color_cluster_shortcut			pal[windialog_coloridx_cluster_shortcut].value

/*
 *	Tag palette
 */

#define tag_palette_str			"tags"
#define tag_palette_colors		8
#define tag_color_normal			pal[tag_coloridx_normal].value
#define tag_color_edit_cursor_edit	pal[tag_coloridx_edit_cursor_edit].value
#define tag_color_edit_cursor_sel	pal[tag_coloridx_edit_cursor_sel].value
#define tag_color_edit_modified	pal[tag_coloridx_edit_modified].value
#define tag_color_edit_selected	pal[tag_coloridx_edit_selected].value
#define tag_color_edit_normal		pal[tag_coloridx_edit_normal].value
#define tag_color_sel_cursor		pal[tag_coloridx_sel_cursor].value
#define tag_color_sel_normal		pal[tag_coloridx_sel_normal].value

/*
 *	INIT
 */

int init_color();

/*
 *	DONE
 */

int done_color();

#endif /* __HTCOLOR_H__ */
