/* 
 *	HT Editor
 *	htelf.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htelf.h"
#include "htelfhd.h"
#include "htstream.h"

#include "elfstruc.h"

int htelf_detect(ht_stream *file)
{
	elf32_unsigned_char ident[EI_NIDENT];
	file->seek(0);
	file->read(&ident, sizeof ident);
	if ((ident[EI_MAG0]==ELFMAG0) && (ident[EI_MAG1]==ELFMAG1) &&
		(ident[EI_MAG2]==ELFMAG2) && (ident[EI_MAG3]==ELFMAG3) ){
		return 1;
	}
	return 0;
}

ht_view *htelf_init(bounds *b, ht_stream *file, ht_group *group)
{
	ht_elf *g=new ht_elf();
	g->init(b, file);
	insert_int(g, file, &htelfheader_int);
	return g;
}

viewer_int htelf_int = {
	htelf_detect,
	htelf_init
};

void ht_elf::init(bounds *b, ht_stream *file)
{
	ht_xgroup::init(b, VO_SELECTABLE | VO_BROWSABLE, DESC_ELF);
	VIEW_DEBUG_NAME("ht_elf");
/*	mz_shared=new ht_mz_shared_data;
	file->seek(0);
	file->read(&mz_shared->header, sizeof mz_shared->header);
	shared_data=mz_shared;*/
}

void ht_elf::done()
{
	ht_xgroup::done();
}
