/* 
 *	HT Editor
 *	htleimg.h
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __HTLEIMG_H__
#define __HTLEIMG_H__

#include "htstream.h"

#include "viewers.h"

/*
 *	CLASS ht_le_page_stream
 */

class ht_le_page_stream: public ht_layer_stream {
protected:
	ht_le_pagemap *pagemap;
	dword page_size;
	dword ofs;
/* new */
	int map_ofs(dword ofs, dword *result, dword *maxsize);
public:
	ht_le_page_stream(ht_stream *stream, int own_stream, ht_le_pagemap *pagemap, dword page_size);
	~ht_le_page_stream();
/* overwritten */
	int isdirty(dword offset, int range);
	dword read(void *buf, dword size);
	int seek(dword offset);
	dword tell();
	dword write(void *buf, dword size);
};

extern viewer_int htleimage_int;

#endif /* !__HTLEIMG_H__ */

