/* 
 *	HT Editor
 *	htleobj.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htnewexe.h"
#include "htle.h"
#include "htleobj.h"
#include "httag.h"
#include "htstring.h"
#include "viewers.h"

#include "lestruct.h"

#include <stdlib.h>
#include <string.h>

char *leobj[]=
{
	"virtual size                                     "STATICTAG_EDIT_DWORD("00000000"),
	"relocation base address                          "STATICTAG_EDIT_DWORD("00000004"),
	"flags                                            "STATICTAG_EDIT_DWORD("00000008"),
	"    readable "STATICTAG_EDIT_BIT("00000008", "00")"    writeable "STATICTAG_EDIT_BIT("00000008", "01")"    executable "STATICTAG_EDIT_BIT("00000008", "02"),
	"page map index                                   "STATICTAG_EDIT_DWORD("0000000c"),
	"page map count                                   "STATICTAG_EDIT_DWORD("00000010"),
	"name                                             "STATICTAG_EDIT_CHAR("00000014")""STATICTAG_EDIT_CHAR("00000015")""STATICTAG_EDIT_CHAR("00000016")""STATICTAG_EDIT_CHAR("00000017"),
	0
};
/*#define IMAGE_LE_OBJECT_FLAG_READABLE		0x00000001
#define IMAGE_LE_OBJECT_FLAG_WRITEABLE		0x00000002
#define IMAGE_LE_OBJECT_FLAG_EXECUTABLE		0x00000004
#define IMAGE_LE_OBJECT_FLAG_RESOURCE		0x00000008
#define IMAGE_LE_OBJECT_FLAG_DISCARDABLE	0x00000010
#define IMAGE_LE_OBJECT_FLAG_SHARED		0x00000020
#define IMAGE_LE_OBJECT_FLAG_PRELOADED		0x00000040
#define IMAGE_LE_OBJECT_FLAG_INVALID		0x00000080*/

int htleobjects_detect(ht_stream *file)
{
	return 1;
}

ht_view *htleobjects_init(bounds *b, ht_stream *file, ht_group *group)
{
	ht_group *le_group=group;
	while (strcmp(le_group->desc, DESC_LE)) le_group=le_group->group;
	ht_le_shared_data *le_shared=(ht_le_shared_data *)((ht_le*)le_group)->shared_data;

	int h=le_shared->hdr_ofs;
	ht_uviewer *v=new ht_uviewer();
	v->init(b, DESC_LE_OBJECTS, file, VC_EDIT);
	hts_mask *m=new hts_mask();
	m->init(file);

	char t[64];
	sprintf(t, "* LE object headers at offset %08lx", h+le_shared->hdr.objtab);
	m->add_mask(t);
	le_shared->objmap.count=le_shared->hdr.objcnt;
	le_shared->objmap.header=(IMAGE_LE_OBJECT_HEADER*)malloc(le_shared->objmap.count*sizeof *le_shared->objmap.header);
	le_shared->objmap.size=(dword*)malloc(le_shared->objmap.count*sizeof *le_shared->objmap.size);

	for (dword i=0; i<le_shared->hdr.objcnt; i++) {
		int j=0;
		char n[5];
		file->seek(h+le_shared->hdr.objtab+i*24);
		file->read(&le_shared->objmap.header[i], sizeof *le_shared->objmap.header);

/* sum up page sizes to find object size */
		dword size=0;
		for (dword j=0; j<le_shared->objmap.header[i].page_map_count; j++) {
			size+=le_shared->pagemap.size[j+le_shared->objmap.header[i].page_map_index-1];
		}
		le_shared->objmap.size[i]=size;

		memmove(&n, le_shared->objmap.header[i].name, 4);
		n[4]=0;
		sprintf(t, "--- object %ld: %s ---", i, (char*)&n);
		m->add_mask(t);
		while (leobj[j]) {
			char *s=strdup(leobj[j]);
			m->add_staticmask(s, h+le_shared->hdr.objtab+i*24);
			delete s;
			j++;
		}
	}

	v->insertsub(m);

	le_shared->v_objects=v;
	return v;
}

viewer_int htleobjects_int = {
	htleobjects_detect,
	htleobjects_init
};

