/* 
 *	HT Editor
 *	htmenu.h
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __HTMENU_H__
#define __HTMENU_H__

#include "htdata.h"
#include "htdialog.h"
#include "htobj.h"

/*
 *	CLASS ht_menu
 */

class ht_context_menu_entry: public ht_data {
public:
	char *name;
	char *shortcut;
	char *comment;
	int command;
	int active;
};

class ht_menu_cat: public ht_data {
public:
	int xpos;
	int width;
	char *name;
	char *shortcut;
	ht_collection *context_menu_entry;
};

class ht_menu: public ht_view {
protected:
	int lastcatx;
	ht_collection *menu_cat;
	int cur_cat;
public:
			void init(bounds *b);
	virtual	void done();
/* overwritten */
	virtual	void defaultpalette();
	virtual	void draw();
	virtual	void handlemsg(htmsg *msg);
/* new */
			int insert_cat(char *name);
			int insert_entry(int cat, char *name, char *comment, int command, int active);
			int insert_separator(int cat);
};

/*
 *	CLASS ht_context_menu_window
 */

class ht_context_menu_window_body;

struct ht_context_menu_window_data {
	int selected;
};

class ht_context_menu_window: public ht_dialog {
protected:
	ht_context_menu_window_body *body;
public:
			void init(bounds *b, ht_collection *context_menu_entry);
	virtual	void done();
/* overwritten */
	virtual	void getdata(void *buf);
	virtual	void setdata(void *buf);
};

/*
 *	CLASS ht_context_menu_window_body
 */

class ht_context_menu_window_body: public ht_view {
protected:
	ht_collection *context_menu_entry;
	int selected;
/* new */
	int next_selectable(int to);
	int prev_selectable(int to);
public:
			void init(bounds *b, ht_collection *context_menu_entry);
	virtual	void done();
/* overwritten */
	virtual	void defaultpalette();
	virtual	void draw();
	virtual	void handlemsg(htmsg *msg);
	virtual	void getdata(void *buf);
	virtual	void setdata(void *buf);
};

/*
 *	CLASS ht_menu_window
 */

class ht_menu_window_body;

class ht_menu_window: public ht_dialog {
protected:
	ht_menu_window_body *body;
public:
			void init(bounds *b, ht_collection *context_menu_entry);
	virtual	void done();
/* overwritten */
	virtual	void getdata(void *buf);
	virtual	void setdata(void *buf);
};

/*
 *	CLASS ht_menu_window_body
 */

class ht_menu_window_body: public ht_context_menu_window_body {
public:
			void init(bounds *b, ht_collection *context_menu_entry);
	virtual	void done();
/* overwritten */
	virtual	void handlemsg(htmsg *msg);
};

/*
 *	CLASS ht_menu_frame
 */

class ht_menu_frame: public ht_frame {
protected:
/* overwritten */
	virtual	int getcurcol_normal();
	virtual	int getcurcol_killer();
public:
			void init(bounds *b, char *desc, int number, int style);
	virtual 	void done();
/* overwritten */
	virtual	void defaultpalette();
};

/*
 *	INIT
 */

int init_menu();

/*
 *	DONE
 */

void done_menu();

#endif /* !__HTMENU_H__ */
