/* 
 *	HT Editor
 *	htmzimg.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htmz.h"
#include "htmzimg.h"
#include "htpal.h"
#include "htstring.h"
#include "htviewer.h"
#include "viewers.h"
#include "x86dis.h"

int htmzimage_detect(ht_stream *file)
{
	return 1;
}

ht_view *htmzimage_init(bounds *b, ht_stream *file, ht_group *group)
{
	ht_group *mz_group=group;
	while (strcmp(mz_group->desc, DESC_MZ)) mz_group=mz_group->group;
	ht_mz_shared_data *mz_shared=(ht_mz_shared_data *)((ht_mz*)mz_group)->shared_data;

	dword o=mz_shared->header.header_size*16;
	ht_uviewer *v=new ht_uviewer();
	v->init(b, DESC_MZ_IMAGE, file, VC_EDIT);
	hts_mask *m=new hts_mask();
	m->init(file);
	char info[128];
	sprintf(info, "* MZ image at offset %08lx", o);
	m->add_mask(info);
	v->insertsub(m);

	x86dis *disasm=new x86dis(X86_OPSIZE16, X86_ADDRSIZE16);

	hts_unasm *d=new hts_unasm();
	d->init(file, o, (mz_shared->header.sizep-1)*512+
		mz_shared->header.sizelp-16*mz_shared->header.header_size,
		disasm, X86DIS_STYLE_OPTIMIZE_ADDR);
	v->insertsub(d);
	return v;
}

viewer_int htmzimage_int = {
	htmzimage_detect,
	htmzimage_init
};

