/* 
 *	HT Editor
 *	htmzrel.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "htmz.h"
#include "htmzrel.h"
#include "htpal.h"
#include "httag.h"
#include "viewers.h"

int htmzrel_detect(ht_stream *file)
{
	word rcount;
	file->seek(6);
	file->read(&rcount, 2);
	return rcount;
}

ht_view *htmzrel_init(bounds *b, ht_stream *file, ht_group *group)
{
	ht_uviewer *v=new ht_uviewer();
	v->init(b, DESC_MZ_REL, file, VC_EDIT);
	ADDR r=0;
	dword rc=0;
	file->seek(6);
	file->read(&rc, 2);
	file->seek(24);
	file->read(&r, 2);
	char buf[256];
	hts_mask *m=new hts_mask();
	m->init(file);
	char info[128];
	sprintf(info, "* MZ relocations at offset %08lx", r);
	m->add_mask(info);
	for (int i=rc; i>0; i--) {
		int so;
		file->seek(r);
		file->read(&so, 4);
		char *b=tag_make_edit_word(buf, r+2);
		*(b++)=':';
		b=tag_make_edit_word(b, r);
		*b=0;
		m->add_mask(buf);
		r+=4;
	}
	v->insertsub(m);
	return v;
}

viewer_int htmzrel_int = {
	htmzrel_detect,
	htmzrel_init
};
