/* 
 *	HT Editor
 *	htstring.h
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __HTSTRING_H__
#define __HTSTRING_H__

#include "global.h"
#include "config.h"

/* make sure we have strdup */

#ifdef HAVE_STRDUP

#include <string.h>

#else

char *strdup(char *str);

#endif

/* common string parsing functions */

void whitespaces(char **str);
int waitforchar(char **str, char b);

/* string evaluation functions */

extern char *eval_int_errstr;
int eval_int_expr(char *str, dword *v);
int eval_int_expr_custom(char *str, dword *v, void *eval_proc_context, int (*eval_proc)(void *context, char **s, dword *v));

int bnstr(char **str, dword *v, int defaultbase);

/* hex/string functions */

int hexdigit(char a);

dword hexb(char *s);
dword hexw(char *s);
dword hexd(char *s);

char *mkhexb(char *buf, byte d);
char *mkhexw(char *buf, word d);
char *mkhexd(char *buf, dword d);

/* C/ASM strings */

extern char *casmerrstr;
byte *eval_casmstr(char *str, int *ret_strlen);

#endif /* !__HTSTRING_H__ */
