/* 
 *	HT Editor
 *	viewers.cc
 *
 *	Copyright (C) 1999,2000 Stefan Weyergraf (stefan@weyergraf.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "viewers.h"

#include "htelf.h"
#include "hthex.h"
#include "htmz.h"
#include "htle.h"
#include "htpe.h"

viewer_int *viewer_ints[] =
{
	&hthex_int,
	&htelf_int,
	&htmz_int,
	&htpe_int,
	&htle_int,
	0
};

void insert_int(ht_group *group, ht_stream *file, viewer_int *i)
{
	bounds b;
	group->getbounds(&b);
	b.x=0;
	b.y=0;
	if ((i->init) && (i->detect) && (i->detect(file))) {
		ht_view *v=i->init(&b, file, group);
		if (v) {
		    v->sendmsg(htm_complete_init, 0);
		    group->insert(v);
		}		    
	}
}

